/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.army.entities;

import fb.battlefield.Sprite;

/**
 * an entity able to fly
 * @author farfpeuf
 *
 */
public interface FlyingEntity {
	/**
	 * @return sprite used when flying
	 */
	public Sprite getFlyingSprite();
	/**
	 * @return shadow sprite used when flying
	 */
	public Sprite getShadowSprite();	
	/**
	 * can this entity do a take off manoeuvre
	 * 
	 * @return true if it can
	 */
	public boolean canTakeOff();	
	/**
	 * can this entity do a land manoeuvre
	 * 
	 * @return true if it can
	 */
	public boolean canLand();
	/**
	 * do take off manoeuvre
	 * 
	 */
	public void doTakeOff();
	/**
	 * do land manoeuvre
	 * 
	 */
	public void doLand();
	/**
	 * take off manoeuvre
	 * 
	 */
	public void takeOff();
	/**
	 * land manoeuvre
	 * 
	 */
	public void land();

}
