/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.army.hierarchy;

import fb.army.entities.Banner;
import fb.army.entities.Exterminator;
import fb.army.entities.Herald;
import fb.army.entities.Hero;
import fb.army.entities.Legend;
import fb.util.Resources;
import fb.util.StringTools;
/**
 * a stranger command
 * @author farfpeuf
 *
 */
public class StrangerCommand extends Command {

	/**
	 * check command content before saving
	 * 
	 * @return null if command is ok or an error message
	 */
	public String check(){
		String message=super.check();
		if (numberOf((new Hero(null,0)).getClass())>0){
			message += Resources.getString("cannotContainHero");		
		}
		if (numberOf((new Legend(null,0)).getClass())>0){
			message += Resources.getString("cannotContainPaladin");		
		}
		if (numberOf((new Exterminator(null,0)).getClass())>0){
			message += Resources.getString("cannotContainDestroyer");		
		}	
		if (numberOf((new Herald(null,0)).getClass())>0){
			message += Resources.getString("cannotContainHerald");		
		}
		if (numberOf((new Banner(null,0)).getClass())>0){
			message += Resources.getString("cannotContainBanner");		
		}
		
		message = StringTools.replaceAll(message, "<group name>", name);

		return message;
	}
}
