/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.frames;

import javax.swing.JPanel;

import fb.gui.widgets.ButtonListener;
import fb.gui.widgets.FBButton;
import fb.gui.widgets.FBTextArea;
import fb.main.FB;
import fb.util.PercentageLayout;
import fb.util.Resources;

/**
 * frame used to display game manual
 * 
 * @author farfpeuf
 */
public class ManualFrame extends JPanel {

	/**
	 * singleton instance
	 */
	private static ManualFrame instance;

	/**
	 * get singleton instance
	 * 
	 * @return the singleton
	 */
	public static synchronized  ManualFrame getInstance() {
		if (null == instance) {
			instance = new ManualFrame();
		}
		return instance;
	}

	/**
	 * delete singleton to free memory
	 * 
	 */
	public static  synchronized void freeInstance() {
		if (null != instance) {
			instance = null;
		}
	}

	/**
	 * constructor
	 * 
	 * build and assemble elements
	 * 
	 */
	private ManualFrame() {
		super();

		FBButton back = new FBButton(Resources.getString("Exittomainmenu"));

		back.addActionListener(new ButtonListener() {
			public void threadedActionPerformed() {
				FB.getInstance().displayMainMenuFrame();
			}
		});

		FBTextArea manualPanel = new FBTextArea(false);

		manualPanel.setText(Resources.getManual());
		manualPanel.setOpaque(false);
		manualPanel.validate();

		manualPanel.setBounds((int) ((800 * FB.getXres() - 500) / 2),
				(int) ((600 * FB.getYres() - 500) / 2), 500, 500);

		setLayout(new PercentageLayout());

		add(manualPanel, new PercentageLayout.Constraint(5, 5, 90, 80));
		add(back, new PercentageLayout.Constraint(40, 90, 20, 4));

		setOpaque(false);
		setSize((int) (800 * FB.getXres()), (int) (600 * FB.getYres()));

	}

}
