/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.panels;

import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import fb.army.entities.Leader;
import fb.gui.widgets.SlideValueChooser;
import fb.util.FBColors;
import fb.util.PercentageLayout;
import fb.util.Resources;

/**
 * additionnal panel to display leader recruitment options
 * 
 * @author farfpeuf
 * 
 */
class LeaderRecruitPanel extends RecruitPanel {
	/**
	 * current leader
	 */
	private Leader leader;

	/**
	 * widget to chose leadership
	 */
	private SlideValueChooser leadershipChooser;

	/**
	 * leader cost label
	 */
	private JLabel cost;

	/**
	 * constructor build and assemble panel elements
	 */
	public LeaderRecruitPanel() {

		JPanel cadrePanel = new JPanel();
		setBorder(BorderFactory.createLineBorder(FBColors.lightBorder));

		cadrePanel.setLayout(new PercentageLayout());
		leadershipChooser = new SlideValueChooser(" "
				+ Resources.getString("Leadership") + " :");
		cost = new JLabel();
		cost.setHorizontalAlignment(0);
		cadrePanel.add(leadershipChooser, new PercentageLayout.Constraint(10, 0,
				80, 66));
		cadrePanel.add(cost, new PercentageLayout.Constraint(0, 66, 100, 34));

		setLayout(new GridLayout(1, 1));
		add(cadrePanel);

		validate();

		leadershipChooser.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				leader.setLeadership(((JSlider) e.getSource()).getValue());
				fireEntityChanged();
				cost.setText(" " + Resources.getString("Cost") + " : "
						+ leader.getCost());
			}
		});
		leadershipChooser.setToolTipText(Resources.getString("authority.tt"));
	}

	/**
	 * change leader
	 * 
	 * @param leader
	 *            the new leader
	 */
	public void setLeader(Leader leader) {
		this.leader = leader;
		leadershipChooser.setValues(1, 5, leader.getLeadership());
	}

}
