/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.widgets;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

import fb.army.entities.Entity;

/**
 * renderer to display a line of the entities catalog
 * 
 * @author farfpeuf
 * 
 */
public class CatalogCell extends JLabel implements ListCellRenderer {

	/**
	 * ListCellRenderer implementation
	 */
	public Component getListCellRendererComponent(JList list, Object value,
			int index, boolean isSelected, boolean cellHasFocus) {

		Entity e = (Entity) value;

		setToolTipText(e.getTooltip());

		if (e.isEnabled()) {
			if (isSelected) {
				setBackground(list.getSelectionBackground());
				setForeground(list.getSelectionForeground());
			} else {
				setBackground(list.getBackground());
				setForeground(list.getForeground());
			}
		} else {
			if (isSelected) {
				setBackground(list.getSelectionBackground());
				setForeground(Color.lightGray);
			} else {
				setBackground(list.getBackground());
				setForeground(Color.darkGray);
			}
		}
		setIcon(e.getMinicon());
		setDisabledIcon(e.getMinicon());
		setEnabled(list.isEnabled());
		setFont(list.getFont());
		setText(e.getFullName());
		return this;
	}
}
