/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.widgets;

import java.util.Vector;

import javax.swing.ComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.plaf.basic.BasicComboBoxUI;

/**
 * a fantasy battlefields custom combo box
 * 
 * @author Farfpeuf
 */
public class FBComboBox extends JComboBox {
	/**
	 * customize combo ui
	 * 
	 */
	private void customize() {
		setUI(new BasicComboBoxUI() {
			protected JButton createArrowButton() {
				return new FBButton("", "combo");
			}
		});
		setRenderer(new ComboBoxRenderer());
	}

	/**
	 * Constructor for FBCombo.
	 * 
	 * @param arg0
	 *            combo data model
	 */
	public FBComboBox(ComboBoxModel arg0) {
		super(arg0);
		customize();
	}

	/**
	 * Constructor for FBCombo.
	 * 
	 * @param arg0
	 *            array of elements
	 */
	public FBComboBox(Object[] arg0) {
		super(arg0);
		customize();
	}

	/**
	 * Constructor for FBCombo.
	 * 
	 * @param arg0
	 *            vector of elements
	 */
	public FBComboBox(Vector arg0) {
		super(arg0);
		customize();
	}

	/**
	 * Constructor for FBCombo.
	 */
	public FBComboBox() {
		super();
		customize();

	}

}
