/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.sound;

import java.awt.BorderLayout;
import java.awt.Color;
import java.io.File;
import java.io.InputStream;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;

import fb.util.FileTools;
import fb.util.Resources;
import fb.util.StringTools;

/**
 * an ogg to wav sound converter
 * 
 * @author farfpeuf
 * 
 */
public class OggToWavGenerator {

	/**
	 * the conversion progress bar
	 */
	private JProgressBar pb;

	/**
	 * constructor show dialog to ask user confirmation
	 */
	public OggToWavGenerator() {
		int rep = JOptionPane.showConfirmDialog(null, Resources
				.getString("mp3towavquestion"), Resources
				.getString("mp3towavtitle"), JOptionPane.OK_CANCEL_OPTION);
		if (rep == JOptionPane.CANCEL_OPTION) {
			System.exit(0);
		} else if (rep == JOptionPane.OK_OPTION) {
			pb = new JProgressBar(2, 100);
			pb.setStringPainted(true);

			JFrame frame = new JFrame(Resources.getString("mp3towavtitle"));
			frame.setBackground(Color.white);
			frame.getContentPane().setLayout(new BorderLayout());
			frame.getContentPane().add(pb, "Center");
			frame.pack();
			frame.setSize(350, 70);
			frame.setLocation((frame.getToolkit().getScreenSize().width - frame
					.getSize().width) / 2,
					(frame.getToolkit().getScreenSize().height - frame
							.getSize().height) / 2);
			frame.show();
			String path = "ogg";

			convert(path);
			frame.dispose();
		}
	}

	/**
	 * convert ogg files to wav files
	 * 
	 * @param path
	 *            the file or directory path
	 */
	public void convert(String path) {
		try {
			File wav = new File(StringTools.replaceAll(path, "ogg", "wav"));

			if (FileTools.isDirectory(path)) {
				if (!wav.exists()) {
					wav.mkdir();
				}
				List subfiles = FileTools.list(path);
				String subPath;
				for (int i = 0; i < subfiles.size(); i++) {
					subPath = (String) subfiles.get(i);
					convert(path + "/" + subPath);
				}

			} else if (path.indexOf(".ogg") != -1) {
				InputStream input_stream = ClassLoader
						.getSystemResourceAsStream(path.replace(
								File.separatorChar, '/'));
				wav.getParentFile().mkdirs();
				OggDecoder decoder = new OggDecoder();
				decoder.decode(input_stream, wav);

				pb.setValue(pb.getValue() + 1);
				pb.setString(Integer.toString(pb.getValue()) + "%");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
