/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.spells;

import fb.army.entities.Daemon;
import fb.army.entities.Entity;
import fb.util.D6;

/**
 * summon a daemon that will join the wizard's army
 * 
 * @author farfpeuf
 * 
 */
public class SummonDaemon extends BasicSpell {

	// private static final ImageIcon[] effects =
	// FB.getInstance().fireballicons;
	/**
	 * constructor
	 */
	public SummonDaemon() {
		super();
		name = "summon";
	}

	/**
	 * cast the spell
	 * 
	 * @return true if the spell was successfull
	 */
	public boolean castSpell() {
		if (caster.spendMagicPoints(cost())) {
			return true;
		}
		return false;
	}

	/**
	 * @return spell cost
	 */
	public int cost() {
		return D6.roll() + D6.roll() + D6.roll();
	}

	/**
	 * @return spell maximum cost
	 */
	public int maxCost() {
		return 18;
	}

	/**
	 * @return spell minimum cost
	 */
	public int minCost() {
		return 3;
	}

	/**
	 * @return spell average cost
	 */
	public int averageCost() {
		return 10;
	}

	/**
	 * is this entity a potential target for specified actor
	 * 
	 * @param a
	 *            spell actor
	 * @param e
	 *            spell target
	 * @return true if this entity is a potential target for specified actor
	 */
	public boolean isTarget(Entity a, Entity e) {
		return false;
	}

	/**
	 * is this entity a potential target for current actor
	 * 
	 * @param e
	 *            spell target
	 * @return true if this entity is a potential target for current spell
	 *         caster
	 */
	public boolean isTarget(Entity e) {
		return false;
	}

	/**
	 * end the spell
	 * 
	 * @throws InterruptedException
	 */
	public void endSpell() throws InterruptedException {
		Daemon.summon(caster);
		magicSynchronize();
	}

}