/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.util;

import java.util.Random;

/**
 * an X-sided dice
 * 
 * @author farfpeuf
 * 
 */
public class DX {

	/**
	 * the random number generator instance
	 */
	private static Random randomNumberGenerator;

	/**
	 * roll the dice
	 * 
	 * @param x
	 *            the number of sides
	 * @return the dice score
	 */
	public static int roll(int x) {
		if (x > 0) {
			if (randomNumberGenerator == null) {
				initRNG();
			}
			return randomNumberGenerator.nextInt(x) + 1;
		} else {
			return 0;
		}
	}

	/**
	 * initialize the random number generator
	 * 
	 */
	private static synchronized void initRNG() {
		if (randomNumberGenerator == null) {
			randomNumberGenerator = new Random();
		}
	}

}
